﻿#ifndef _PROJECT_AUTO_LABEL_H_
#define _PROJECT_AUTO_LABEL_H_
#include "QtPlatform.h"
#include "WidgetSizer.h"

#include "QtGui/QPen"


class CAutoLabel : public QWidget, public CWidgetSizer<CAutoLabel>
{
public:
	Q_OBJECT
public:
    CAutoLabel(QWidget *parent, QString content , int id =0,QColor backGroundColor = QColor(255,255,255));
	virtual ~CAutoLabel();
	void paintEvent(QPaintEvent *event);
	void resizeEvent(QResizeEvent *event);
	void mouseMoveEvent(QMouseEvent *_event);

	void SetTextFont(QFont& font);
	QFont& GetTextFont();
    void SetTextPen(QPen pen);
	QPen& GetTextPen();
	void InitLabel(void);
	QRect GetTextRect();
	
	void SetTextMaximumWidth(int width){ maxWidth = width; }
	int GetTextMaximumWidth(){ return maxWidth; }
signals:
	void labelResize(int id,QRect rect);
private:
	int				_id;
	QRect			_rect;
	QColor			_backGroundColor;
	QPen			_pen;
	QFont			_font;
	QString			_content;

	int				_textWidth;
	int				_textHeigth;
	int maxWidth;
};



#endif
