﻿#include "AutoLabel.h"
#include <QtGui/QPainter>
CAutoLabel::CAutoLabel(QWidget *parent, QString content , int id, QColor backGroundColor )
	: QWidget(parent), _content(content), _id(id), _backGroundColor(backGroundColor)
{
	_textWidth = 0;
	_textHeigth = 0;
	_id	= 0;
	_rect = QRect(0,0,0,0);
	InitLabel();
}
CAutoLabel::~CAutoLabel()
{

}
void CAutoLabel::paintEvent(QPaintEvent *event)
{
	QPainter dc(this);

	dc.setFont(_font);
	dc.setPen(_pen);
	int tempHeigth = 0;
	QRect contentRect = dc.fontMetrics().boundingRect(_content);
	if (_content.contains('\n', Qt::CaseSensitive) || _content.contains('\r', Qt::CaseSensitive))
	{
	}
	else
	{
		_textWidth = maxWidth;
		tempHeigth = (contentRect.width() / maxWidth) * (contentRect.height());
		if ((contentRect.width() % maxWidth) > 0)
		{
			tempHeigth += contentRect.height();
		}
	}
	if (_textHeigth != tempHeigth)
	{
		_textHeigth = tempHeigth;
		if (contentRect.width() < maxWidth)
		{
			_textWidth = contentRect.width();
		}
		emit labelResize(_id, QRect(0, 0, _textWidth, _textHeigth));
		return;
	}
	dc.fillRect(_rect, QBrush(_backGroundColor));
	dc.drawText(0,0,_textWidth,_textHeigth,Qt::TextWrapAnywhere , _content);
}
void CAutoLabel::resizeEvent(QResizeEvent *event)
{
	QRect rect = this->frameGeometry();
	_rect = QRect(0, 0, rect.width(), rect.height());

	/*QPainter dc(this);
	dc.setFont(_font);
	dc.setPen(_pen);
	int tempHeigth = 0;
	QRect contentRect = dc.fontMetrics().boundingRect(_content);
	if (_content.contains('\n', Qt::CaseSensitive) || _content.contains('\r', Qt::CaseSensitive))
	{
	}
	else
	{
	_textWidth = maxWidth;
	tempHeigth = (contentRect.width() / maxWidth) * (contentRect.height() + _font.wordSpacing());
	if ((contentRect.width() % maxWidth) > 0)
	{
	tempHeigth += contentRect.height() + _font.wordSpacing();
	}
	}
	if (_textHeigth != tempHeigth)
	{
	_textHeigth = tempHeigth;
	if (contentRect.width() < maxWidth)
	{
	_textWidth = contentRect.width();
	}
	emit labelResize(_id, QRect(0, 0, _textWidth, _textHeigth));
	}*/
	
}

void CAutoLabel::mouseMoveEvent(QMouseEvent *_event)
{
	setCursor(Qt::ArrowCursor);
}

void CAutoLabel::SetTextFont(QFont& font)
{
	_font = font;
}
void CAutoLabel::SetTextPen(QPen pen)
{
	_pen = pen;
}
QPen& CAutoLabel::GetTextPen()
{
	return _pen;
}

QFont& CAutoLabel::GetTextFont()
{
	return _font;
}
void CAutoLabel::InitLabel(void)
{
#ifdef _MSC_VER
    _font.setFamily("Microsoft YaHei");
#endif
	_font.setPixelSize(12);
	_pen.setColor(QColor(0x00,0x00,0x00));
}
QRect CAutoLabel::GetTextRect()
{
	return QRect(0, 0, _textWidth, _textHeigth);
}
