﻿#ifndef _DISABLE_BUTTON2_H_
#define _DISABLE_BUTTON2_H_

#include <QtGui/qimage.h>
#include "QtPlatform.h"

#include "WidgetSizer.h"

class CButton2Disable : public QWidget, public CWidgetSizer<CButton2Disable>
{
public:
	Q_OBJECT
public:
	CButton2Disable(QWidget *_parent, int x, int y, const char* image_file)
		: QWidget(_parent)
	{
		_image = new QImage(image_file);
		this->setEnabled(true);
		int width = _image->width();
		int height = _image->height();

		setGeometry(QRect(x,y,width / 3,height));

		setMouseTracking(true);
		_state = 1;
	}
	~CButton2Disable()
	{
		if (_image != NULL)
		{
			delete _image;
		}
	}


signals:

	void click();

protected:

	void paintEvent(QPaintEvent *event)
	{
		QPainter painter(this);
		int w = _image->width() / 3;
		int h = _image->height();

		if (!this->isEnabled())
		{
			painter.drawImage(0,0,*_image,0,0,w,h);
		}
		else
		{
			painter.drawImage(0,0,*_image,w*_state,0,w,h);
		}
	}

	void leaveEvent(QEvent *event)
	{
		_state = 1;
		repaint();
	}

	void mousePressEvent(QMouseEvent* event)
	{
		if (event->button() == Qt::LeftButton)
		{
			_state = 2;
			repaint();
		}
		event->accept();
		activateWindow();
        //setFocus(Qt::MouseFocusReason);
	}

	void mouseMoveEvent(QMouseEvent *event)
	{
		if (_state != 2)
		{
			_state = 2;
			repaint();
		}
		setCursor(Qt::ArrowCursor);
	}

	void mouseReleaseEvent(QMouseEvent* event)
	{
		if (event->button() == Qt::LeftButton)
		{
			_state = 1;
			repaint();
			if (rect().contains(event->pos()))
			{
				emit click();
			}
		}
		event->accept();
	}

	void mouseDoubleClickEvent(QMouseEvent * event)
	{
		event->accept();
	}
	void focusInEvent(QFocusEvent * event)
	{
		_state = 2;
		repaint();
	}
	void focusOutEvent(QFocusEvent *event)
	{
		_state = 1;
		repaint();
	}
private:
	QImage*		_image;
	int			_state;
};
#endif
