﻿

#ifndef __FRAME_WINDOW_H__
#define __FRAME_WINDOW_H__

#include "QtPlatform.h"


// 顶级窗口的基类



class FrameWindow : public QDialog
{
public:
	enum DragType
	{
		DragNone,		// 没有拖动
		DragClient,		// 拖动内部区域
		DragTop,
		DragLeft,
		DragBottom,
		DragRight,
		DragTopLeft,
		DragTopRight,
		DragBottomLeft,
		DragBottomRight,
	};
public:

	Q_OBJECT

public:
	FrameWindow(QWidget *parent = 0, Qt::WindowFlags flags = Qt::FramelessWindowHint);
	virtual ~FrameWindow();

	void mousePressEvent(QMouseEvent *event);
	void mouseReleaseEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);

	void resizeEvent(QResizeEvent * event);

	virtual DragType Hittest(int x, int y);

	void SetRoundRadius(int round);
	void DrawBorder(QPainter& painterDc);
private:

	DragType				_drag_type;

	QPoint					_down_pos;
	QRect					_down_rc;
	int						_round_radius;
};


#endif
