﻿
#ifndef __LINE_EDIT_H__
#define __LINE_EDIT_H__



#include "RoundRadiusWnd.h"
#include "WidgetSizer.h"

class QLineEditExt:public QLineEdit
{
public:
	Q_OBJECT
public:
	QLineEditExt(const QString text, QWidget* parent);
	~QLineEditExt();
public:
	void inputMethodEvent(QInputMethodEvent *);
signals:
	void MethodStringIn(QString commitString, QString preeditString);
private:

};


class CLineEdit : public CRoundRadiusWnd, public CWidgetSizer<CLineEdit>
{
public:

	Q_OBJECT
public:

    CLineEdit( int id, QWidget* parent, QString text, QColor color);
	virtual ~CLineEdit();

	#define TEXT_LEFT_SPACE_VAL		2

public:

	QString GetText();
	QLineEdit* GetEditObj();
    void SetText(QString text);
	void SetReadOnly(bool );
	void SetAlignFlag(int flag);
	void EnablePassword(bool is_enable);
	void setValidator(const QValidator * v);
	void SetMaxLength(unsigned int length);
	void HideFrame();

	void SetBackgroundImg(const QString img);
	void SetEmptyText(const QString emptyStr);
signals:

	void textChanged();

protected:

	virtual void paintEvent(QPaintEvent *event);
	virtual void resizeEvent(QResizeEvent *event);
	virtual void ResetTextRect(QRect& rc);
protected slots:

	void ChangeText(const QString text);
	void HandleMethodStringIn(QString commitString, QString preeditString);
protected:
	int				_id;
	QRect			_rect;
	QRect			_textRect;
	QColor			_backGroundColor;
	QString			_backGroundImgStr;

	bool			_is_show_frame;
	
	int				_textAlignFlag;
	int				_radius;
	QString			_text;
	QLineEditExt*		_textEditor;
	QString _empty_str;
	bool _isMethodInPut;
};


#endif

