﻿#ifndef _PROJECT_LIST_FRAME_TEMPLATE_H_
#define _PROJECT_LIST_FRAME_TEMPLATE_H_

#include "QtPlatform.h"
#include "WidgetSizer.h"
#include "VScroll.h"
#define SCROLL_WIDTH 10;


class CVScroll;
class CListItemBase;

typedef bool (*frame_sort)(CListItemBase* obj1, CListItemBase* obj2);

class CListBase : public QWidget, public CWidgetSizer<CListBase>
{
public:
	Q_OBJECT
public:
    CListBase(QWidget* parent, QColor backGroundColor = QColor(255,255,255), int setFlag = 255);
	virtual ~CListBase();
	//
	virtual void PushBack(CListItemBase* item);
	virtual void PushFront(CListItemBase* item);
	virtual void Insert(CListItemBase* fitem, CListItemBase* item);
	void Erase(CListItemBase* item);
	void Erase(int itemId);
	void ClearAll();
	bool IsEmpty();
	void SetItemWidth(int width);
	void SetItemHeight(int height);
	void SetScrollWidth(int width);
	void SetScrollPos(int pos);
	void SetEmptyString(QString str);

	int GetShowMax();
	int GetSize();
	int CreateUniquenessId();
	CVScroll* GetSCroll();
	void sort(frame_sort func);

	int GetMaxID();
	void SetModeScrollAtEnd(){ _scrollAt = CVScroll::InitAtBottom; }
	CListItemBase* GetItemByItemId(unsigned int);
	CListItemBase* GetItemByIndex(unsigned int index);
protected:
	int  ItemHittest(int pos);
	int  GetAllItemHeight( );
	void LayOut();


	virtual void paintEvent(QPaintEvent *event);
	virtual void mousePressEvent(QMouseEvent *event);
	virtual void leaveEvent(QEvent *event);
	virtual void mouseReleaseEvent(QMouseEvent *event);
	virtual void mouseMoveEvent(QMouseEvent *event);
	virtual void resizeEvent(QResizeEvent * event);
	virtual void wheelEvent(QWheelEvent * event);
public:
signals:
	void click(CListItemBase* item);
	void clickBtn(CListItemBase* item, unsigned int option);
	void doubleClick(CListItemBase* item);
	void onBottom();
public slots:
void ChangeItemSize(CListItemBase* item, QRect);
void ReceiveClickEvent(CListItemBase* item);
void ReceiveDoubleClickEvent(CListItemBase* item);
void ReceiveClickBtnEvent(CListItemBase* item, unsigned int option);
protected:
	
	QRect			_rect;
	int				_Id;
	QColor			_backGroundColor;
	QList<CListItemBase*>		_list;

	CVScroll*		_vscroll;
	int				_scrollPos;
	int				_isScrollPosChanged;
	int				_itemShowMax;
	int				_itemAllHeight;
	int				_scrollWidth;

	int				_itemHeight;
	int				_itemWidth;

	int             _itemUniquenessId;
	CVScroll::PosAt				_scrollAt;
	QString			_emptyStr;
};

#endif
