﻿#include "ListItemBase.h"
#include <QtGui/qpainter.h>
#include "QtGui/qevent.h"
CListItemBase::CListItemBase( QWidget* parent, QColor backColor, QColor hitBackColor)
: QWidget(parent), _backGroundColor(backColor), _hitBackGroundColor(hitBackColor)
{

	_isMouseIn = false;
	_itemHeight = 40;
	_itemWidth =  100;
	this->setGeometry(0,0,_itemWidth, _itemHeight);
}
CListItemBase::CListItemBase(QWidget* parent)
	: QWidget(parent)
{

	_isMouseIn = false;
	_itemHeight = 40;
	_itemWidth =  100;
	this->setGeometry(0,0,_itemWidth, _itemHeight);
}
void CListItemBase::ItemRectChange( QRect rect)
{
	emit needResize(this, QRect(0, 0, _rect.width(), _itemHeight));
}
void CListItemBase::ReceiveClickEventFromBtn()
{

}
void CListItemBase::resizeEvent(QResizeEvent *event)
{
	QRect rect = this->frameGeometry();
	_rect = QRect(0,0,rect.width(),rect.height());
	if (_itemWidth != _rect.width())
	{
		_itemWidth = _rect.width();
	}
}
void CListItemBase::enterEvent(QEvent *event)
{
	if (_isMouseIn == false)
	{
		_isMouseIn = true;
		emit onItemActive(this, true);
		repaint();
	}
	event->accept();
}
void CListItemBase::leaveEvent(QEvent *event)
{
	if (_isMouseIn == true)
	{
		_isMouseIn = false;
		emit onItemActive(this, false);
		repaint();
	}
	event->accept();
}
void CListItemBase::mouseDoubleClickEvent(QMouseEvent * event)
{
	emit doubleClick(this);
}
void CListItemBase::mousePressEvent(QMouseEvent *event)
{
	emit click(this);
}

void CListItemBase::mouseMoveEvent(QMouseEvent *_event)
{
	setCursor(Qt::ArrowCursor);
}

void CListItemBase::paintEvent( QPaintEvent *event )
{
	pain();
}

void CListItemBase::pain()
{
	QPainter dc(this);
	if (_isMouseIn == false)
	{
		dc.fillRect(_rect, QBrush(_backGroundColor));
	}
	else
	{
		dc.fillRect(_rect, QBrush(_hitBackGroundColor));
	}
}

void CListItemBase::SetBackGroundColor(QColor color)
{
	_backGroundColor = color;
}

void CListItemBase::SetHitBackGroundColor(QColor color)
{
	_hitBackGroundColor = color;
}

bool CListItemBase::IsMouseIn()
{
	return _isMouseIn;
}

void CListItemBase::ClickOperateBtn( int eType )
{

}

void CListItemBase::SetId(int id)
{
	_id = id;
}

