﻿#ifndef _PROJECT_LIST_ITEM_BASE_H_
#define _PROJECT_LIST_ITEM_BASE_H_
#include "QtPlatform.h"
#include "WidgetSizer.h"

class CListItemBase : public QWidget, public CWidgetSizer<CListItemBase>
{
public:
	Q_OBJECT
public:
	CListItemBase(QWidget* parent);
	CListItemBase(QWidget* parent,QColor backColor, QColor hitBackColor);
	int GetId(){return _id;}
	virtual void SetBackGroundColor(QColor color);
	virtual void SetHitBackGroundColor(QColor color);
	virtual void SetId(int id);
	virtual bool IsMouseIn();
	virtual ~CListItemBase(){}
	virtual int GetItemHeight(){ return _itemHeight; }
protected:
	virtual void pain();
	virtual void paintEvent(QPaintEvent *event);
	virtual void resizeEvent(QResizeEvent *event);
	virtual void enterEvent(QEvent *event);
	virtual void leaveEvent(QEvent *event);
	virtual void mouseDoubleClickEvent(QMouseEvent * event);
	virtual void mousePressEvent(QMouseEvent *event);
	virtual void mouseMoveEvent(QMouseEvent *_event);

public:
signals:
	void needResize(CListItemBase* item, QRect rect);
	void onItemActive(CListItemBase* item, bool active);
	void click(CListItemBase* item);
	void doubleClick(CListItemBase* item);
	void clickBtn(CListItemBase* item, unsigned int option);
	void clickOptBtn(CListItemBase* item, unsigned int option);
public slots:
	virtual void ItemRectChange( QRect rect);
	virtual void ReceiveClickEventFromBtn();
	virtual void ClickOperateBtn(int eType);
protected:
	int		_id;
	QRect	_rect;
	QColor	_backGroundColor;
	QColor	_hitBackGroundColor;
	int		_itemHeight;
	int		_itemWidth;

	bool	_isMouseIn;
};
#endif

