﻿#ifndef _MESSAGE_BOX_DIALOG_H_
#define _MESSAGE_BOX_DIALOG_H_

#include "QtPlatform.h"
#include "FrameWindow.h"
#include "WidgetSizer.h"

class CButton2;
class CButton3;
class CTextLabel;



class CMessageDialog : public FrameWindow,  public CWidgetSizer<CMessageDialog>
{
public:
	 enum StandardButton {
		 No_Button	= 0x00000000,
		 Close		= 0x00000001,
		 Ok			= 0x00000002,
		 Cancel		= 0x00000004,
		 Normal		= Close | Ok | Cancel,
	 };
public:
	Q_OBJECT
public:
    CMessageDialog(QWidget* parent, QString title, QString content, StandardButton buttons = Normal);
	virtual ~CMessageDialog();
	void SetAlignFlag(int flag);
	/*virtual int exec();*/
protected:
	virtual void paintEvent(QPaintEvent *event);
	virtual void resizeEvent(QResizeEvent *event);


	virtual void ShowButtons(StandardButton buttons);
	virtual void InitMessageDialog();
public slots:
	virtual void ClickButton();
private:
private:


	QPoint					_down_pos;
	QRect					_down_rc;
	int						_round_radius;

	int				_id;
	QColor			_backGroundColor;

	QString			_title;
	QString			_content;

	CButton2*		_closeBtn;
	CButton3*		_okBtn;
	CButton3*		_cancelBtn;
	StandardButton  _buttonsFlag;
	CTextLabel*		_textLabel;

};


#endif
