﻿#ifndef _ROUND_RADIUS_WINDOW_H_
#define _ROUND_RADIUS_WINDOW_H_

#include "QtPlatform.h"


class CRoundRadiusWnd : public QWidget
{
public:
	enum DragType
	{
		DragNone,		// 没有拖动
		DragClient,		// 拖动内部区域
		DragTop,
		DragLeft,
		DragBottom,
		DragRight,
		DragTopLeft,
		DragTopRight,
		DragBottomLeft,
		DragBottomRight,
	};
public:

	Q_OBJECT

public:
	CRoundRadiusWnd(QWidget *parent = 0, Qt::WindowFlags flags = Qt::FramelessWindowHint);
	virtual ~CRoundRadiusWnd();

	void mousePressEvent(QMouseEvent *event);
	void mouseReleaseEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);

	void resizeEvent(QResizeEvent * event);

	virtual DragType Hittest(int x, int y);
	void SetMoveWndEnable(bool enableToMove);
	void SetRoundRadius(int round);
	void DrawBorder(QPainter& painterDc);

private:

	DragType				_drag_type;

	QPoint					_down_pos;
	QRect					_down_rc;
	int						_round_radius;
	bool					_can_move_wnd;

};
#endif
