

#ifndef __TEXT_BUTTON2_H__
#define __TEXT_BUTTON2_H__


#include <QtGui/qimage.h>

#include "RoundRadiusWnd.h"
#include "WidgetSizer.h"


using namespace std;

class CTextButton1Disable : public CRoundRadiusWnd, public CWidgetSizer < CTextButton1Disable >
{
public:
	Q_OBJECT
public:
	QColor	_enable_color;
	QColor _disable_color;
	QString _btn_text;
	QColor	_text_color;
	QFont	_text_font;
	CTextButton1Disable(QWidget *parent, int x, int y, QColor enableColor, QColor disableColor, QString btnText)
		:CRoundRadiusWnd(parent)
	{
		_enable_color = enableColor;
		_disable_color = disableColor;
		_btn_text = btnText;
		setMouseTracking(true);
	}

	~CTextButton1Disable()
	{

	}

	void SetTextParams(QColor textColor, int textPixelSize, QString textFamily, bool isBold)
	{
		_text_color = textColor;
		_text_font.setPixelSize(textPixelSize);
		_text_font.setFamily(textFamily);
		_text_font.setBold(isBold);
	}

signals:

	void click();

protected:

	void paintEvent(QPaintEvent *_event)
	{
		QPainter painter(this);
		if (isEnabled())
		{
			painter.fillRect(rect(), _enable_color);
		}
		else
		{
			painter.fillRect(rect(), _disable_color);

		}
		painter.setPen(_text_color);
		painter.setFont(_text_font);
		painter.drawText(rect(), Qt::AlignCenter, _btn_text);

	}
	void resizeEvent(QResizeEvent * event)
	{
		CRoundRadiusWnd::resizeEvent(event);

	}
	void leaveEvent(QEvent *event)
	{
	}

	void mousePressEvent(QMouseEvent* event)
	{
		event->accept();
		activateWindow();
		//setFocus(Qt::MouseFocusReason);
	}

	void mouseMoveEvent(QMouseEvent *_event)
	{
		setCursor(Qt::ArrowCursor);
	}

	void mouseReleaseEvent(QMouseEvent* event)
	{
		if (event->button() == Qt::LeftButton)
		{
			repaint();
			if (rect().contains(event->pos()))
			{
				emit click();
			}
		}
		event->accept();
	}

	void mouseDoubleClickEvent(QMouseEvent* event)
	{
		event->accept();
	}

private:

};


#endif


