﻿#ifndef _EDIT_BOX_CONTROL_H_
#define _EDIT_BOX_CONTROL_H_

#include "QtPlatform.h"
#include "WidgetSizer.h"


#define BOX_TEXT_LEFT_SPACE_VAL		2

class QTextEdit;
class CTextEdit : public QWidget, public CWidgetSizer<CTextEdit>
{
public:
	typedef enum
	{
		SingleLineEditBox,
		MultiLineEditBox,
	}EditType;
	Q_OBJECT
public:
    CTextEdit( int id, QWidget* parent, QString text, QColor color);
	virtual ~CTextEdit();

public:

	QString GetText();
	QTextEdit* GetEditObj();
    void SetText(QString text);
	void SetReadOnly(bool );
	void SetEditType(EditType type);
	void SetAlignFlag(int flag);
	void SetTextLimitCount(int count);
	void InstallEventFilter(QObject *obj);
	bool EditHasFocus();
	void SetEditFocus();
	void HideFrame();

signals:
	void textChanged();

protected:
	virtual void paintEvent(QPaintEvent *event);
	virtual void resizeEvent(QResizeEvent *event);
	virtual void ResetTextRect(QRect& rc);
	virtual bool LimitTextLenth(int lenth);
	protected slots:
		void ChangeText();
protected:
	int				_id;
	QRect			_rect;
	QRect			_textRect;
	QColor			_backGroundColor;
	bool			_is_show_frame;
	
	int				_textAlignFlag;
	EditType		_editType;
	QString			_text;
	int				_textMaxCount;
	QTextEdit*		_textEditor;
	

};
class CButton2;

#endif
