﻿#include "TextLabel.h"

CTextLabel::CTextLabel( QWidget *parent, QString content , QColor backGroundColor /*= QColor(255,255,255)*/, Qt::WindowFlags frameFlag /*= 0*/ )
	 : CRoundRadiusWnd(parent,frameFlag), _content(content), _backGroundColor(backGroundColor)
{
	_id = 0;
	InitLabel();
	SetRoundRadius(0);
}

CTextLabel::~CTextLabel()
{

}

void CTextLabel::SetTextFont( QFont& font )
{
	_font = font;
}

void CTextLabel::SetTextPen( QPen pen )
{
	_pen = pen;
}

void CTextLabel::SetAlignFlag( int flag )
{
	_alignFlag = flag;
}

void CTextLabel::paintEvent( QPaintEvent *event )
{
	QPainter dc(this);
	dc.setFont(_font);
	dc.setPen(_pen);
	dc.fillRect(_rect, QBrush(_backGroundColor));
	dc.drawText(_rect,_alignFlag,_content);
}

void CTextLabel::resizeEvent( QResizeEvent *event )
{
	CRoundRadiusWnd::resizeEvent(event);
	QRect rect = this->frameGeometry();
	_rect = QRect(0,0,rect.width(),rect.height());
}

void CTextLabel::InitLabel( void )
{
	_alignFlag = Qt::AlignVCenter | Qt::TextWrapAnywhere ;
	_pen.setColor(QColor(0x33,0x33,0x33));
	_font.setPixelSize(12);
#ifdef _MSC_VER
    _font.setFamily("Microsoft YaHei");
#endif
}

void CTextLabel::SetContent( QString str )
{
	_content = str;
	repaint();
}

void CTextLabel::AppendContent( QString str )
{
	_content.append(str);
	repaint();
}

void CTextLabel::mousePressEvent( QMouseEvent *event )
{
	
}

void CTextLabel::mouseMoveEvent( QMouseEvent *event )
{

}

void CTextLabel::mouseReleaseEvent( QMouseEvent *event )
{
	if (event->button() == Qt::LeftButton)
	{
		if (rect().contains(event->pos()))
		{
			emit click();
		}
	}
	event->accept();
}


