﻿#ifndef _TEXT_LABEL_H_
#define _TEXT_LABEL_H_
#include "QtPlatform.h"
#include <QtGui/qpen.h>
#include "RoundRadiusWnd.h"
#include "WidgetSizer.h"
class CTextLabel : public CRoundRadiusWnd, public CWidgetSizer<CTextLabel>
{
public:
	Q_OBJECT
public:
    CTextLabel(QWidget *parent, QString content , QColor backGroundColor = QColor(255,255,255), Qt::WindowFlags frameFlag = 0);
	virtual ~CTextLabel();

	void SetTextFont(QFont& font);
    void SetTextPen(QPen pen);
	void SetAlignFlag(int flag);
	void SetContent(QString str);
	void AppendContent(QString str);

signals:

	void click();

protected:

	void mousePressEvent(QMouseEvent *event);
	void mouseReleaseEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);
	virtual void paintEvent(QPaintEvent *event);
	virtual void resizeEvent(QResizeEvent *event);
	virtual void InitLabel(void);

private:

	int				_id;
	int				_alignFlag;
	QRect			_rect;
	QColor			_backGroundColor;
	QPen			_pen;
	QFont			_font;
	QString			_content;

};
#endif
