#ifndef __OPEN_AVD_N2M_AudioList_H__
#define __OPEN_AVD_N2M_AudioList_H__

#include "FrameWindow.h"
#include "ListItemBase.h"
#include "ListBase.h"
#include "api/maudio.h"

using namespace tee3::avd;
class CButton2;

class CDeviceListItem : public CListItemBase
{
public:
	Q_OBJECT
public:
	CDeviceListItem(QWidget* parent, const tee3::avd::Device& item, QColor bg_color, QColor bg_hit_color);
	void setCurrentFlag(bool iscurrent);
	tee3::avd::Device& GetDevice(){ return _item; }
protected:
	void pain();
protected:
	tee3::avd::Device _item;
	bool m_iscurrent;
};

class CDeviceList : public CListBase
{
public:
	Q_OBJECT
public:
	CDeviceList(QWidget* parent, QColor bg_color);
	void AddDeviceItem(const tee3::avd::Device& item, bool isCurrent);
};

class CDeviceListView : public FrameWindow
{
public:
	Q_OBJECT
public:
	CDeviceListView(IAudioDevice* screen, tee3::avd::Device& item, QColor backColor, bool isSpeaker);
	~CDeviceListView(){};
public:
	tee3::avd::Device& GetDevice(){ return _current; }
	void setCurrent(tee3::avd::Device& current);
	static bool selectCurrentDevice(tee3::avd::IAudioDevice* device, tee3::avd::Device& item, bool isSpeaker);
	static bool selectCurrentDevice(QPoint moveTo, tee3::avd::IAudioDevice* device, tee3::avd::Device& item, bool isSpeaker);
protected:
	void resizeEvent(QResizeEvent * event);
	void paintEvent(QPaintEvent *event);
public slots:
	void HandleDoubleClick(CListItemBase* item);
	void HandleCloseClick();
private:
	IAudioDevice* _sdk;
	CDeviceList* _device_list;
	QColor _back_ground_color;
	CButton2* _wnd_close_btn;
	tee3::avd::Device _current;
	bool _isSpeaker;
	static int g_width;
	static int g_height;
};

#endif //__OPEN_AVD_N2M_AudioList_H__
