#ifndef __OPEN_AVD_N2M_AudioPage_H__
#define __OPEN_AVD_N2M_AudioPage_H__

#include "WidgetSizer.h"
#include "Button1.h"
#include "api/maudio.h"

using namespace tee3;
using namespace tee3::avd;
class RoomWindow;
class CUserPage;

class CAudioPage : public IMAudio::IListener, public IAudioDevice::IListener {
public:
	 CAudioPage(RoomWindow* parent);
	~CAudioPage();

	void RegistAudioHandle(IMAudio* audioHandle);
	bool OpenAudio(const UserId& nodeId);
	bool CloseAudio(const UserId& nodeId);
	bool OpenAudio();
	bool CloseAudio();
	void MonitorAudioLevel(bool isMonitor);
	IAudioDevice* getAudioDevice() const { return m_audioDevice; }
public:
	// IMAudio::IListener imp
	virtual void onMicrophoneStatusNotify(MicrophoneStatus status, const UserId& fromId);
	virtual void onAudioLevelMonitorNotify(const tee3::avd::AudioInfo& info);
	virtual void onOpenMicrophoneResult(Result result);
	virtual void onCloseMicrophoneResult(Result result);
	// IMAudioDevice::IListener imp
	virtual void onMicrophonePlugin(const Microphone& item);
	virtual void onMicrophonePlugout(const Microphone& item);
	virtual void onSpeakerPlugin(const Speaker& item);
	virtual void onSpeakerPlugout(const Speaker& item);
	virtual void onMicrophoneVolumeChanged(uint32 volume);
	virtual void onSpeakerVolumeChanged(uint32 volume);
private:
	RoomWindow* _room_wnd;
	CUserPage*	_ui_users;
	IMAudio* m_audio;
	IAudioDevice* m_audioDevice;
	UserId m_userId;
};

#endif //__OPEN_AVD_N2M_AudioPage_H__
