﻿#include "ChatMessageItem.h"
#include "AutoLabel.h"
#include "Button1.h"

#include <QtGui/QPainter>
#include <QtGui/QImage>


CChatMessageOtherItem::CChatMessageOtherItem(QWidget* parent, const QString sender, const QString msg)
: CListItemBase(parent, QColor(255, 255, 255), QColor(255, 255, 255)), _user_name(sender), _msg(msg)
{
	//_textLable = new QLabel();
	//_textLable->setMaximumWidth(_itemWidth);
	///*自适应大小,可有可无*/
	//_textLable->adjustSize();
	//_textLable->show();
	///*自动换行*/
	//_textLable->setWordWrap(true);
	//_textLable->setAlignment(Qt::AlignTop);
	_header = new CButton1(this, 10, 10, ":/nice2meet/Resources/image/user_header_other.png");
	_header->show();

	_textLabel = new CAutoLabel(this, msg);
	_textLabel->SetSizer(65, 30, -1, -1, 1, 1);
	connect(_textLabel, SIGNAL(labelResize(int, QRect)), this, SLOT(ItemRectChange(int, QRect)));
	InitTextLabel();

}
void CChatMessageOtherItem::resizeEvent(QResizeEvent *event)
{
	CListItemBase::resizeEvent(event);
	_textLabel->SetTextMaximumWidth(_rect.width() - 85);
	_textLabel->OnSizer();
	_header->OnSizer();
}
void CChatMessageOtherItem::pain()
{
	QPainter dc(this);
	


	QImage bubbleImage(":/nice2meet/Resources/image/other_bubbule.png");
	QRect bubbleRect(55, 25, textWidth, textHeight);
	PainBubule(dc, bubbleImage, 5,5,5,5, bubbleRect);

	QImage leftSharpCornerImage(":/nice2meet/Resources/image/left_sharp_corner.png");
	QRect leftSharpCornerRect(45, 34, 12, 11);
	dc.drawImage(leftSharpCornerRect, leftSharpCornerImage, QRect(0, 0, leftSharpCornerImage.width(), leftSharpCornerImage.height()));

	QFont font = dc.font();
	font.setPixelSize(12);
#ifdef _MSC_VER
	font.setFamily("Microsoft YaHei");
#endif
	dc.setPen(QColor(148, 148, 148));
	dc.setFont(font);
	dc.drawText(55, 20, _user_name);
}

void CChatMessageOtherItem::ItemRectChange(int id, QRect rc)
{
	_itemHeight = rc.height() + 45;
	textHeight = 20 + rc.height();
	textWidth = 20 + rc.width();
	if ((textWidth + 55+10) > rect().width())
	{
		textWidth = rect().width() - 55 - 10;
	}
	_textLabel->SetSizer(65, 35, -1,-1,textWidth-20, textHeight-20);
	_textLabel->SetTextMaximumWidth(textWidth - 20);
	_textLabel->OnSizer();

	CListItemBase::ItemRectChange( rc);
}
CChatMessageOtherItem::~CChatMessageOtherItem()
{

}

void CChatMessageOtherItem::InitTextLabel()
{
	QFont font;
	QPen pen(QColor(148,148,148));
	font.setPixelSize(12);
#ifdef _MSC_VER
	font.setFamily("Microsoft YaHei");
#endif


	_textLabel->SetTextFont(font);
	_textLabel->SetTextPen(pen);
}

void PainBubule(QPainter &dc, QImage& image, int top, int right, int left, int bottom, QRect& rect)
{
	//1	8	7
	//2	9	6
	//3	4	5
	//画左上角
	dc.drawImage(QPoint(rect.left(), rect.top()), image, QRect(0, 0, left, top));
	//画左部分
	dc.drawImage(QRect(rect.left(), rect.top()+top, left, rect.height() - bottom - top), image, QRect(0, top, left, image.height() - bottom - top));
	//画左下部分
	dc.drawImage(QPoint(rect.left(), rect.height() - bottom+rect.top()), image, QRect(0, image.height() - bottom, left, bottom));
	
	//画底部分
	dc.drawImage(QRect(rect.left() + left, rect.height()-bottom+rect.top(), rect.width() - right - left, bottom), image, QRect(left, image.height() - bottom, image.width() - right - left, bottom));
	//画右下部分
	dc.drawImage(QPoint(rect.width() - right + rect.left(), rect.height()-bottom+rect.top()), image, QRect(image.width() - right, image.height() - bottom, right, bottom));
	
	
	//画右部分
	dc.drawImage(QRect(rect.left()+rect.width() - right, top+rect.top(), left, rect.height() - bottom - top), image, QRect(image.width() - right, top, left, image.height() - bottom - top));
	//画右上部分
	dc.drawImage(QPoint(rect.left()+rect.width() - right, rect.top()), image, QRect(image.width() - right, 0, right, top));
	//画顶部
	dc.drawImage(QRect(rect.left()+left, rect.top(), rect.width() - right - left, top), image, QRect(left, 0, image.width() - right - left, top));
	//画中间部分
	dc.drawImage(QRect(rect.left()+left, top+rect.top(), rect.width() - right - left, rect.height() - bottom - top), image, QRect(left, top, image.width() - right - left, image.height() - bottom - top));

}


CChatMessageSelfItem::CChatMessageSelfItem(QWidget* parent, const QString sender, const QString msg)
: CListItemBase(parent, QColor(255, 255, 255), QColor(255, 255, 255)), _sender(sender), _msg(msg)
{
	//_textLable = new QLabel();
	//_textLable->setMaximumWidth(_itemWidth);
	///*自适应大小,可有可无*/
	//_textLable->adjustSize();
	//_textLable->show();
	///*自动换行*/
	//_textLable->setWordWrap(true);
	//_textLable->setAlignment(Qt::AlignTop);
	_header = new CButton1(this, -1,-1, ":/nice2meet/Resources/image/user_header_self.png");
	_header->SetSizer(-1, 10, 10, -1, 30, 30);
	_header->show();

	_textLabel = new CAutoLabel(this, msg, 0, QColor(216,231,251));
	_textLabel->SetSizer(-1, 15, 55, -1,1, 1);
	//_textLabel->show();
	connect(_textLabel, SIGNAL(labelResize(int, QRect)), this, SLOT(ItemRectChange(int, QRect)));
	InitTextLabel();

}
void CChatMessageSelfItem::resizeEvent(QResizeEvent *event)
{
	CListItemBase::resizeEvent(event);
	
	_textLabel->SetTextMaximumWidth(_rect.width() - 85);
	_textLabel->OnSizer();

	_header->OnSizer();

}
void CChatMessageSelfItem::pain()
{
	QPainter dc(this);



	QImage bubbleImage(":/nice2meet/Resources/image/self_bubbule.png");
	QRect bubbleRect(rect().width()-textWidth-55, 14, textWidth, textHeight);
	PainBubule(dc, bubbleImage, 5, 5, 5, 5, bubbleRect);

	QImage leftSharpCornerImage(":/nice2meet/Resources/image/right_sharp_corner.png");
	QRect leftSharpCornerRect(rect().width()-(10+30+5+12), 22, 12, 11);
	dc.drawImage(leftSharpCornerRect, leftSharpCornerImage, QRect(0, 0, leftSharpCornerImage.width(), leftSharpCornerImage.height()));

}

void CChatMessageSelfItem::ItemRectChange(int id, QRect rc)
{
	_itemHeight = rc.height() + 20+10+10;
	textHeight = 20 + rc.height();
	textWidth = 20 + rc.width();
	if ((textWidth + 55 + 10) > rect().width())
	{
		textWidth = rect().width() - 55 - 10;
	}
	_textLabel->SetSizer(-1, 24, 65, -1, textWidth - 20, textHeight - 20);
	_textLabel->SetTextMaximumWidth(textWidth - 20);
	_textLabel->OnSizer();

	CListItemBase::ItemRectChange(rc);
}
CChatMessageSelfItem::~CChatMessageSelfItem()
{

}

void CChatMessageSelfItem::InitTextLabel()
{
	QFont font;
	QPen pen(QColor(51,51,51));
	font.setPixelSize(12);
	//font.setWordSpacing(5);
#ifdef _MSC_VER
	font.setFamily("Microsoft YaHei");
#endif


	_textLabel->SetTextFont(font);
	_textLabel->SetTextPen(pen);
}