#ifndef __OPEN_AVD_N2M_ChatPage_H__
#define __OPEN_AVD_N2M_ChatPage_H__

#include "RoundRadiusWnd.h"
#include "WidgetSizer.h"
#include "Button1.h"
#include "Button2.h"
#include "api/mchat.h"

using tee3::avd::IMChat;

class CChatHistoryBoard;
class CChatInput;
class CButton2;
class CChatButton;
class RoomWindow;

class CChatPage : public CRoundRadiusWnd, public CWidgetSizer<CChatPage>, public IMChat::IListener
{
public:
	Q_OBJECT
public:
	CChatPage(RoomWindow* parent);
	~CChatPage();
	void OnReceiveMsg(QString userName, QString msg);
	void SetMsgNumWnd(CChatButton* msgNum){ _msg_num = msgNum; }
	void RegistChatHandle(IMChat* chat);
	virtual void onPublicMessage(const tee3::avd::Message& message);
	virtual void onPrivateMessage(const tee3::avd::Message& message);
protected:
	void paintEvent(QPaintEvent *event);
	void resizeEvent(QResizeEvent *event);
	protected slots:
	void HandleSendMsg( QString msg );
	void HideWnd();
private:
	QColor _bg_color;
	
	CChatHistoryBoard*		_history_board;
	CChatInput*				_input_wnd;
	CButton2*				_close_btn;
	CChatButton*			_msg_num;
	IMChat*					m_chat;
	RoomWindow* _room_wnd;
};

class CChatButton : public CButton2
{
public:
	CChatButton(QWidget *_parent, int x, int y, const char* image_file);
	~CChatButton ();
	void SetMsgNum(int num);
	int GetMsgNum();
	void Add(int index);
	void paintEvent(QPaintEvent *_event);
private:
	int msg_num;
};

#endif //__OPEN_AVD_N2M_ChatPage_H__
