#ifndef __Open_AVD_DEMO_InviteDlg_H__
#define __Open_AVD_DEMO_InviteDlg_H__
#include "UIDefine.h"
#include "QtPlatform.h"
#include "FrameWindow.h"
#include "WidgetSizer.h"
#include "ui_InviteDlg.h"
#include "api/avdlive.h"
#include "api/avdrecord.h"

using namespace tee3;
using namespace tee3::avd;
class CInviteDlg : public FrameWindow, public CWidgetSizer<CInviteDlg> {
	Q_OBJECT
public:
	 CInviteDlg(QWidget* parent);
	~CInviteDlg();
public:
	void clearRecordLiveInfos();
	void updateRecordInfos(const RecordInfosType& infos);
	void updateLiveInfos(const LiveInfosType& infos);
	void setVisible(bool visible);
protected slots:
	void setClipboard();
	void hideWnd();
	void playItem(QTableWidgetItem*);
	void changedOperate();
	void playRecord();
	void downloadRecord();
	void copylink2Clipboard();
protected:
	void InitUIStyle();
	void InitUIData();
	QString status2String(RecordStatus status) const;
	QString status2String(LiveStatus status) const;
	void enableLiveRecordOp(bool enable);
	QTableWidgetItem* getSelectedItem(bool& isLive);
	void playdownloadcopyItem(int mode);
private:
	Ui::CInviteDlg ui;
	QString _roomId;
	QString _inviteLink;
	IAVDRecord* _record;
	IAVDLive*	_live;
	QString		_urlbase;
	struct StatusName {
		int status;
		QString name;
	};
};
#endif //__Open_AVD_DEMO_InviteDlg_H__
