#include "InviteLinkWnd.h"
#include "Button1.h"
#include "Button2.h"
#include "TextButton1.h"
#include "MessageBoxFactory.h"
#include "UIManager.h"
#include "QtGui/qpainter.h"
#include "../roomprofile.h"

CInviteLinkWnd::~CInviteLinkWnd()
{

}

CInviteLinkWnd::CInviteLinkWnd(QWidget* parent)
	:CRoundRadiusWnd(parent)
{
	SetRoundRadius(8);
	//_copy_link_btn = new CButton1(this, 30, 169, ":/nice2meet/Resources/image/copy_link_btn.png");
	_copy_link_btn = new CTextButton1(this, -1, -1, QColor(0,96,153), QSTRING("˰ťƻ"));
	_copy_link_btn->SetRoundRadius(8);
	_copy_link_btn->SetTextParams(QColor(255, 255, 255), 14, QSTRING("Microsoft YaHei"), true);
	_copy_link_btn->SetSizer(48, 150, 48, -1, -1, 40);
	_close_btn = new CButton2(this, -1,-1, ":/nice2meet/Resources/image/close_box_btn.png");
	_close_btn->SetSizer(-1, 11, 10, -1, 13, 13);

	_inviteLink = "asdfad";

	connect(_copy_link_btn, SIGNAL(click()), this, SLOT(setClipboard()));
	connect(_close_btn, SIGNAL(click()), this, SLOT(hideWnd()));

}

void CInviteLinkWnd::paintEvent(QPaintEvent *event)
{
	QPainter dc(this);
	//background
	dc.fillRect(rect(), QColor(38,37,42, (int)(255 * 0.95)));
	//title
	//dc.fillRect(QRect(0, 0, rect().width(), 50), QColor(0, 159, 250));
	dc.setPen(QColor(140, 144, 153));
	QFont font = dc.font();
	font.setPixelSize(14);
	font.setFamily(QSTRING("Microsoft YaHei"));
	dc.setFont(font);
	dc.drawText(QRect(10, 0, rect().width(), 36), Qt::AlignLeft | Qt::AlignVCenter, QSTRING("˲λ"));

	//title spliter
	QBrush brsh = dc.brush();
	dc.setPen(QColor(38, 37, 42));
	QLinearGradient linearGradient(1, 36, 1, 40);
	linearGradient.setColorAt(0, QColor(1, 1, 1));
	linearGradient.setColorAt(1.0, QColor(38, 37, 42));
	dc.setBrush(QBrush(linearGradient));
	dc.drawRect(0, 36, rect().width(), 4);
	dc.setBrush(brsh);
	
	//invitelink
	//dc.setPen(QColor(212, 212, 212));
	dc.setPen(QColor(140, 144, 153));
	font.setPixelSize(14);
	font.setFamily(QSTRING("Microsoft YaHei"));
	dc.setFont(font);
	dc.drawText(50, 70+14, QSTRING("ұţ")+_roomId);
	dc.drawText(50, 110 + 14, QSTRING("URL")+_inviteLink);

	dc.setPen(QColor(1, 1, 1));
	DrawBorder(dc);

}

void CInviteLinkWnd::resizeEvent(QResizeEvent* event)
{
	CRoundRadiusWnd::resizeEvent(event);
	_copy_link_btn->OnSizer();
	_close_btn->OnSizer();
}
void CInviteLinkWnd::hideWnd()
{
	hide();
}
void CInviteLinkWnd::setClipboard()
{
	QClipboard *clipboard = QApplication::clipboard();
	clipboard->setText(_inviteLink);

	MessageBoxFactory::Get()->CreateMessageBox(MessageBoxFactory::ChildAutoBox, this, QColor(38, 37, 42, (int)(255 * 0.95)), "", QSTRING("ѳɹƵа壡"),
		QRect(10, rect().height() - 50, rect().width() - 20, 50), 5000);
}

void CInviteLinkWnd::SetRoomId(const QString roomId)
{
	_roomId = roomId;
	_inviteLink = CRoomProfile::Instance()->GetInviteUrl() + QSTRING("?roomId=") + _roomId;
}
