#ifndef __LOGIN_WINDOW_H__
#define __LOGIN_WINDOW_H__
#include "FrameWindow.h"

class CTextLabel;
class CTextEdit;
class CLineEdit;
class RoomWindow;
class CTextButton1Disable;
class CButton1;
class QRadioButton;

class LoginWindow : public FrameWindow
{
public:
	Q_OBJECT
public:
	LoginWindow(QWidget* parent = NULL);
	~LoginWindow();
	void ArrangeRoomError(int result);

public:
	void setEnabled(bool enable);
	void resizeEvent(QResizeEvent * event);
	void paintEvent(QPaintEvent *event);
	void keyPressEvent(QKeyEvent *event);
	void closeEvent(QCloseEvent *event);

	void SetRoomID(const char* roomID);
	void joinConference(QString room_id);
protected slots:
	void joinOrCreateConference();
	void Close();
		
private:
	void createConference();
private:
	CLineEdit*		_user_name_edit;
	CLineEdit*		_conf_url_edit;
	CLineEdit*		_password_edit;
	CTextButton1Disable* _join_or_create_conf;
	QButtonGroup*	_group_mode;
	QRadioButton*	_mode_mcu;
	QRadioButton*	_mode_p2p;
	CButton1*		_close_btn;
	QString			_default_url;
	QString			_default_user_name;
	QString			_default_user_password;
	RoomWindow*		_main_wnd;
	QColor			_back_ground_color;
	CButton1*		_logo_btn;
};
LoginWindow* GetLoginWnd();
#endif
