#include "QtGui/qpainter.h"
#include "MainToolWnd.h"
#include "Button2.h"
#include "ChatPage.h"

MainToolWnd::MainToolWnd(QWidget* parent) :QWidget(parent) {
	// 800*43
	int width = 800;
	_help_btn = new CButton2(this, -1, -1, ":/nice2meet/Resources/image/help_btn.png");
	_help_btn->SetSizer(0, 0, -1, -1, 42, 42);

	_videoBtn = new CButton2M2(this, -1, -1, ":/nice2meet/Resources/image/video_open_btn.png",":/nice2meet/Resources/image/video_close_btn.png" );
	_videoBtn->SetState(CButton2M2::State2);
	_videoBtn->SetSizer(-1, 0, 20, -1, 42, 42);
	_videoBtn->show();

	_audioBtn = new CButton2M2(this, -1, -1, ":/nice2meet/Resources/image/audio_open_btn.png", ":/nice2meet/Resources/image/audio_close_btn.png");
	_audioBtn->SetState(CButton2M2::State2);
	_audioBtn->SetSizer(-1, 0, 42 + 20, -1, 42, 42);
	_audioBtn->show();

	_screenBtn = new CButton2M2(this, -1, -1, ":/nice2meet/Resources/image/screen_open_btn.png", ":/nice2meet/Resources/image/screen_close_btn.png");
	_screenBtn->SetState(CButton2M2::State2);
	_screenBtn->SetSizer(-1, 0, 84 + 20, -1, 42, 42);
	_screenBtn->show();
	
	_invite_btn = new CButton2(this, -1, -1, ":/nice2meet/Resources/image/invite_btn.png");
	_attendee_btn = new CButton2(this, -1, -1, ":/nice2meet/Resources/image/attendee_btn.png");
	_chat_btn = new CChatButton(this, -1, -1, ":/nice2meet/Resources/image/chat_btn.png");
	_invite_btn->SetSizer((width - 3 * 42 - 20) / 2, 0, -1, -1, 42, 42);
	_attendee_btn->SetSizer((width - 3 * 42 - 20) / 2 + 42 + 10, 0, -1, -1, 42, 42);
	_chat_btn->SetSizer((width - 3 * 42 - 20) / 2 + 42 * 2 + 10 * 2, 0, -1, -1, 42, 42);
}
MainToolWnd::~MainToolWnd() {
}

void MainToolWnd::resizeEvent(QResizeEvent * event) {
	_help_btn->OnSizer();
	//
	_screenBtn->OnSizer();
	_audioBtn->OnSizer();
	_videoBtn->OnSizer();
	//this btn on the middle of tool bar
	int width = rect().width();
	_invite_btn->SetSizer((width - 3 * 42 - 20) / 2, 0, -1, -1, 42, 42);
	_attendee_btn->SetSizer((width - 3 * 42 - 20) / 2 + 42+10, 0, -1, -1, 42, 42);
	_chat_btn->SetSizer((width - 3 * 42 - 20) / 2 + 42*2+10*2, 0, -1, -1, 42, 42);
	_invite_btn->OnSizer();
	_attendee_btn->OnSizer();
	_chat_btn->OnSizer();
}
void MainToolWnd::paintEvent(QPaintEvent *event) {
	QPainter dc(this);
	dc.fillRect(rect(), QBrush(QColor(23, 25, 29, 229)));
}
void MainToolWnd::showAnimation() {
	//hide();
	//QPropertyAnimation *animation = new QPropertyAnimation(this, "windowOpacity");
	//animation->setDuration(5000);
	//animation->setStartValue(0);
	//animation->setEndValue(1);
	//animation->start();
}
void MainToolWnd::hideAnimation() {
	//show();
	//QPropertyAnimation *animation = new QPropertyAnimation(this, "windowOpacity");
	//animation->setDuration(1000);
	//animation->setStartValue(1);
	//animation->setEndValue(0);
	//animation->start();
}

///
CButton2M2::CButton2M2(QWidget *_parent, int x, int y, const char* state1_image_file, const char* state2_image_file)
	:QWidget(_parent) {
	_state1 = new CButton2(this, -1, -1, state1_image_file);
	_state1->SetSizer(0, 0, 0, 0, -1,-1);
	_state2 = new CButton2(this, -1, -1, state2_image_file);
	_state2->SetSizer(0, 0, 0, 0, -1, -1);
	SetState(State1);
	connect(_state1, SIGNAL(click()), this, SLOT(HandleState1Click()));
	connect(_state2, SIGNAL(click()), this, SLOT(HandleState2Click()));
}
void CButton2M2::resizeEvent(QResizeEvent * event) {
	_state1->OnSizer();
	_state2->OnSizer();
}
void CButton2M2::SetState(STATE state) {
	if (state == State1) {
		_state1->show();
		_state2->hide();
	}
	else {
		_state1->hide();
		_state2->show();
	}
	_state = state;
}
void CButton2M2::HandleState1Click() {
	emit state1Click();
}
void CButton2M2::HandleState2Click() {
	emit state2Click();
}
void CButton2M2::paintEvent(QPaintEvent * event) {
}
void CButton2M2::enterEvent(QEvent *event) {
	emit mouseIn(true);
}
void CButton2M2::leaveEvent(QEvent *event) {
	emit mouseIn(false);
}
