#ifndef _MAIN_TOOL_WND_H_
#define _MAIN_TOOL_WND_H_

#include "WidgetSizer.h"

class CButton2;
class CChatButton;

class CButton2M2 : public QWidget, public CWidgetSizer<CButton2M2>
{
public:
	Q_OBJECT
public:
	enum STATE
	{
		State1,
		State2,
	};
	 CButton2M2(QWidget *_parent, int x, int y, const char* state1_image_file, const char* state2_image_file);
	~CButton2M2(){};
public:
	void resizeEvent(QResizeEvent * event);
	void paintEvent(QPaintEvent * event);
	void enterEvent(QEvent *event);
	void leaveEvent(QEvent *event);
	void SetState(STATE isOpen);
protected slots:
	void HandleState1Click();
	void HandleState2Click();
signals:
	void state1Click();
	void state2Click();
	void mouseIn(bool in);
private:
	STATE	  _state;
	CButton2* _state1;
	CButton2* _state2;
};

class MainToolWnd : public QWidget, public CWidgetSizer<MainToolWnd>
{
public:
	Q_OBJECT
public:
	 MainToolWnd(QWidget* parent);
	~MainToolWnd();
public:
	void resizeEvent(QResizeEvent * event);
	void paintEvent(QPaintEvent *event);
	void showAnimation();
	void hideAnimation();
public:
	CButton2*	_help_btn;
	//
	CButton2*	_invite_btn;
	CButton2*	_attendee_btn;
	CChatButton*_chat_btn;
	//
	CButton2M2* _screenBtn;
	CButton2M2* _audioBtn;
	CButton2M2* _videoBtn;
};
#endif
