#ifndef _MESSAGE_BOX_FACTORY_H_
#define _MESSAGE_BOX_FACTORY_H_

#include "WidgetSizer.h"
#include "RoundRadiusWnd.h"
#include <QtGui/QMovie>

class QToolButton;
class QLabel;
class QTimer;

class ChildMessageNoticeBox : public CRoundRadiusWnd, public CWidgetSizer<ChildMessageNoticeBox>
{
public:
	Q_OBJECT
public:
	ChildMessageNoticeBox(QWidget* parent, QRect showRectInParent, QColor backColor);
	~ChildMessageNoticeBox();
	void SetTipInfo(QString info);
	void SetTipStaticIcon(QPixmap pixmap);
	void SetTipMoveIcon(const QString iconfile);

	bool CloseWidget();
	void SetDestroyTimer(int time);

	public slots:
	void HandleTimeOut();
	signals:
	void TimeOut(int time);
protected:
	void paintEvent(QPaintEvent *event);
	void resizeEvent(QResizeEvent *event);
private:
	QToolButton* close_button;
	QLabel* msg_label;
	QLabel* ask_label;
	QTimer*	show_timer;
	QMovie* _move_icon;
	QColor _back_color;
};


class MessageBoxFactory
{
public:

	enum MessageBoxType
	{
		ChildAutoBox,
		ChildAutoBoxWithMoveIcon,

	};
public:
	static MessageBoxFactory* Get();
	bool CreateMessageBox(MessageBoxType type, QWidget* parent, QColor backColor, const QString tipIcon, const QString content, QRect showRectInParent, int showTime = -1 );
	ChildMessageNoticeBox* CreateChildMessageNoticeBox(MessageBoxType type, QWidget* parent, QColor backColor, const QString tipIcon, const QString content, QRect showRectInParent, int showTime = -1);
protected:
	MessageBoxFactory();
	~MessageBoxFactory();

private:

};
#endif
