#ifndef __XUN_XIN_MAIN_WINDOW_H__
#define __XUN_XIN_MAIN_WINDOW_H__
#include "FrameWindow.h"
#include "WidgetShadow.h"
#include "Button2.h"
#include "Button1.h"
#include "TrayIcon.h"
#include "ui_setting.h"
#include "api/room.h"

class CListBase;
class CVideoRenderWnd;
class CVideoPage;
class CChatPage;
class ScreenSharePage;
class CUserReportPage;
class CChatButton;
class MainToolWnd;
class CInviteDlg;
class CInviteLinkWnd;
class CUserPage;
class CAudioPage;
class CButton2M2;
class TrayIcon;

using namespace tee3;
using namespace tee3::avd;

class SettingWindow;
class RoomWindow : public FrameWindow, IRoom::IListener
{
public:
	Q_OBJECT
public:
	RoomWindow(QWidget* parent = NULL);
	RoomWindow(QWidget* parent , const QString roomId);
	~RoomWindow();
	void CreatAndRegistRoom(const QString roomId);
	void InitUIControl();
	int Join(QString name, QString password);

	void resizeEvent(QResizeEvent * event);
	void paintEvent(QPaintEvent *event);
	void closeEvent(QCloseEvent *event);
	void enterEvent(QEvent *);
	void leaveEvent(QEvent *event);
	IRoom* GetRoomHandle();
public:
	void FreshMainWnd();
	void SetRoomID(const QString id){ _room_id = id;  }
	CChatPage* GetChatPage(){	return _chat_page;	};
	CVideoPage* GetVideoPage(){ return _video_page; };
	CAudioPage* GetAudioPage(){ return _audio_page; }
	CUserPage* GetUserPage(){ return _user_page; }
	MainToolWnd* GetMainToolWnd(){ return _main_btn_tool; }
	CInviteDlg* GetInviteDlg() { return _invite_dlg; }
	void SetVideoState(bool idOpen);
	void SetAudioState(bool isOpen);
	void SetScreenState(bool isOpen);
	void SetRecordingState(bool isrecording);
	
	/// room listener imp 
	void onJoinResult(Result result);
	void onLeaveIndication(Result reason, const UserId& fromId);
	void onPublicData(const char* data, uint32 len, const UserId& fromId);
	void onPrivateData(const char* data, uint32 len, const UserId& fromId);
	void onAppDataNotify(const String& key, const String& value);
	void onRoomStatusNotify(RoomStatus status);
	void onConnectionStatus(ConnectionStatus status);
protected slots:
	void ChatShow();
	void MiniClick();
	void InviteMemberPageShow();
	void HelpPageShow();
	void ShowMax();
	void ShowNormal();
	void AttendeePageShow();
	void CloseAudio();
	void OpenAudio();
	void OpenVideo();
	void CloseVideo();
	void CloseWnd();
	void SelectMicrophone();
	void SelectSpeaker();
	void SwitchCamrea();
	void trayicon_activated(QSystemTrayIcon::ActivationReason reason);
	void MouseInScreenBtn(bool in);
	void OpenScreen();
	void CloseScreen();
	void ShowSetting();
	void SelectResolution();
protected:
	bool event(QEvent *e);
private:
	IRoom*		m_room;
	bool		_isJoin;
	QString		_conf_pass;
	QString		_self_name;
	QString		_room_id;
	ScreenWindow _shared_wnd;
	//
	CVideoPage*		_video_page;
	ScreenSharePage*_screen_page;
	CChatPage*		_chat_page;
	CUserReportPage*_report_page;
	CAudioPage*		_audio_page;
	CInviteLinkWnd*	_invite_wnd;
	CInviteDlg*    _invite_dlg;
	CUserPage*		_user_page;
	CButton2*	_wnd_close_btn;
	CButton2M2*	_wnd_normal_max;
	CButton2*	_wnd_mini;
	CButton2*	_wnd_setting;
	bool		_audio_active;

	//ͼ
	TrayIcon*	_tray_icon;
	QMenu*		_tray_menu;
	//˵Ա
	QAction*	_open_action;
	QAction*	_setting_action;
	QAction*	_change_account_action;
	QAction*	_check_update_action;
	QAction*	_email_action;
	QAction*	_about_action;
	QAction*	_quit_action;
	//ò˵Ա
	QMenu*		_pop_menu;
	QAction*	_menu_sel_microphone;
	QAction*	_menu_sel_speaker;
	QAction*	_menu_switch_camera;
	QAction*	_menu_sel_resolution;

public:
	MainToolWnd*	_main_btn_tool;
	SettingWindow*	_setting_dlg;
};

QApplication* GetApplication();
HWND CreateRenderWindow();

#endif