#ifndef __Open_AVD_DEMO_SETTING_WINDOW_H__
#define __Open_AVD_DEMO_SETTING_WINDOW_H__
#include "UIDefine.h"
#include "QtPlatform.h"
#include "FrameWindow.h"
#include "WidgetSizer.h"
#include "ui_setting.h"
#include "api/rtclogic.h"

class CVideoShowWnd;
class SettingWindow : public FrameWindow, public CWidgetSizer<SettingWindow> {
	Q_OBJECT
public:
	SettingWindow();
	SettingWindow(tee3::avd::IRoom* roomHandle);
	~SettingWindow();

	void InitUIStyle();
	void LoadSettings();
	private slots:
	void on_selectMicCombox_activated(const QString &micName);
	void on_selectSpeakerCombox_activated(const QString &micName);
	void on_selectCameraCombox_activated(const QString &cameraName);
	void on_selectResolutionCombox_activated(const QString & resolutionStr);
	void on_selectRenderModeCombox_activated(const QString & renderModeStr);
	virtual void accept();
	virtual void reject();
signals:
	void videoOptionChanged();
private:
	void LoadResolutions(const tee3::avd::Camera& camera, tee3::avd::CameraCapability& capability);
	void LoadRenderModes();
private:
	Ui::SettingDailog			ui;

	tee3::avd::IRoom*			_roomHandle;
	tee3::avd::IMAudio*			_audioHandle;
	tee3::avd::IMVideo*			_videoHandle;
	tee3::avd::ICameraDevice*	_cameraDeviceHandle;
	tee3::avd::IAudioDevice*	_audioDeviceHandle;
	//tee3::avd::IVideoRender*	_videoRender;
	//tee3::avd::IVideoRenderView*_videoRenderView;
	CVideoShowWnd*				_showWnd;
	bool						_isPreviewed;
public:
	tee3::avd::Microphone		_currentMic;
	tee3::avd::Microphone		_selectMicBak;
	tee3::avd::Speaker			_currentSpeaker;
	tee3::avd::Speaker			_selectSpeakerBak;
	tee3::avd::Camera			_currentCamera;
	tee3::avd::Camera			_selectCameraBak;
	tee3::avd::CameraCapability	_currentCapability;
	tee3::avd::CameraCapability	_selectCapabilityBak;
};

#endif //__Open_AVD_DEMO_SETTING_WINDOW_H__
