#ifndef __UI_MANAGER_H__
#define __UI_MANAGER_H__
#include <QtCore/QString>
#include "RoomWindow.h"
#include "api/rtclogic.h"

using namespace tee3;
using namespace tee3::avd;

//#define __USE_QINIU__
class UIManager :public QObject ,public IAVDEngine::IListener
{
public:
	Q_OBJECT
protected:
	 UIManager();
	~UIManager();
public:
	static UIManager* GetUIManager();
	bool InitAVDEngine();
	bool UninitAEngine();
	/// IAVDEngine::IListener implementation
	virtual void onInitResult(Result result);
	virtual void onUninitResult(Result result);
	virtual void onGetRoomResult(uint32 callId, Result result, const RoomInfo& room);
	virtual void onFindRoomsResult(uint32 callId, Result result, const RoomInfosType& rooms);
	virtual void onScheduleRoomResult(uint32 callId, Result result, const RoomId& roomId);
	virtual void onCancelRoomResult(uint32 callId, Result result, const RoomId& roomId);
public slots:
	RoomWindow* CreateRoomWnd(QString room_id);
	void RemoveRoomWnd(QString room_id);
	void RemoveRoomWnd();
private:
	bool IsMainThread();
private:
	typedef std::map<QString, RoomWindow*>	RoomWindowsType;
	Qt::HANDLE		_ui_main_thread;
	// room windows
	RoomWindowsType	mainWindows;
};
#endif //__UI_MANAGER_H__
