#include "UserList.h"
#include "Button1.h"
#include <QtGui/qpainter.h>

///
#define BTN_Status_Width_Height		22
#define BTN_Status_Top				4
#define BTN_Status_Gap				5
#define BTNS_Status_Right			10		
		
CUserListItem::CUserListItem( QWidget* parent, QString user_name, QColor bg_color, QColor bg_hit_color )
	: CListItemBase(parent, bg_color, bg_hit_color), _user_name(user_name) {
	_itemHeight = 30;
	_audio_level = 0;

	int btn_right = BTNS_Status_Right;
	_btn_status_screen_open = createButton(btn_right, ":/nice2meet/Resources/image/icon_screen_status.png");

	btn_right += (BTN_Status_Gap + BTN_Status_Width_Height);
	_btn_status_video_close = createButton(btn_right, ":/nice2meet/Resources/image/icon_video_status_close.png");
	_btn_status_video_open = createButton(btn_right, ":/nice2meet/Resources/image/icon_video_status.png");

	btn_right += (BTN_Status_Gap + BTN_Status_Width_Height);
	_btn_status_audio_close = createButton(btn_right, ":/nice2meet/Resources/image/icon_audio_status_close.png");
	_btn_status_audio_open = createButton(btn_right, ":/nice2meet/Resources/image/icon_audio_status.png");

	btn_right += (BTN_Status_Gap + BTN_Status_Width_Height);
	_btn_status_audio_level0 = createButton(btn_right, ":/nice2meet/Resources/image/icon_audio_level_1.png");
	_btn_status_audio_level1 = createButton(btn_right, ":/nice2meet/Resources/image/icon_audio_level_2.png");
	_btn_status_audio_level2 = createButton(btn_right, ":/nice2meet/Resources/image/icon_audio_level_3.png");

	connect(_btn_status_audio_close, SIGNAL(click()), this, SLOT(ReceiveClickEventFromBtn()));
	connect(_btn_status_audio_open, SIGNAL(click()), this, SLOT(ReceiveClickEventFromBtn()));
	connect(_btn_status_video_close, SIGNAL(click()), this, SLOT(ReceiveClickEventFromBtn()));
	connect(_btn_status_video_open, SIGNAL(click()), this, SLOT(ReceiveClickEventFromBtn()));
	_audio_timer = new QTimer(this);
	_video_timer = new QTimer(this);
	_audio_timer->setSingleShot(true);
	_video_timer->setSingleShot(true);
	connect(_audio_timer, SIGNAL(timeout()), this, SLOT(UpdateUIWithStatus()));
	connect(_video_timer, SIGNAL(timeout()), this, SLOT(UpdateUIWithStatus()));
}

CUserListItem::~CUserListItem() {
}
CButton1* CUserListItem::createButton(int _right, const char* img) {
	CButton1* item = new CButton1(this, -1, -1, img);
	item->SetSizer(-1, BTN_Status_Top, _right, -1, BTN_Status_Width_Height, BTN_Status_Width_Height);
	item->hide();
	return item;
}
void CUserListItem::pain() {
	QPainter dc(this);
	if (_isMouseIn == false) {
		dc.fillRect(QRect(0,0,_rect.width(), _rect.height()-1), QBrush(_backGroundColor));
	}
	else {
		dc.fillRect(QRect(0, 0, _rect.width(), _rect.height() - 1), QBrush(_hitBackGroundColor));
	}
	// draw User Name
	dc.setPen(QColor(140, 144, 153));
	QFont font;
	font.setPixelSize(12);
	font.setFamily(QSTRING("Microsoft YaHei"));
	dc.setFont(font);
	QString nameStr = _user_name;
	QString roleStr;
	//if (_user_role == tee3::avd::User::host)
	//{
	//	roleStr = QSTRING("()");
	//}
	dc.drawText(QRect(12, 0, rect().width() - 12, rect().height()), Qt::AlignVCenter | Qt::AlignLeft, nameStr + roleStr);
	//dc.drawRect(1, 0, rect().width()-2, rect().height()-1);
}

void CUserListItem::resizeEvent(QResizeEvent *event) {
	CListItemBase::resizeEvent(event);
	_btn_status_audio_close->OnSizer();
	_btn_status_audio_open->OnSizer();
	_btn_status_video_close->OnSizer();
	_btn_status_video_open->OnSizer();
	_btn_status_audio_level0->OnSizer();
	_btn_status_audio_level1->OnSizer();
	_btn_status_audio_level2->OnSizer();
	_btn_status_screen_open->OnSizer();
}

void CUserListItem::ShowRequestOpenVideoBtn(int time) {
	_btn_status_video_open->hide();
	_btn_status_video_close->hide();
	_video_timer->start(time);
}

void CUserListItem::ShowRequestOpenAudioBtn(int time) {
	_btn_status_audio_open->hide();
	_btn_status_audio_close->hide();
	_audio_timer->start(time);
}
void CUserListItem::SetUserStatus(UserStatus status) {
	_user_status = status;
	UpdateUIWithStatus();
}
void CUserListItem::SetAudioLevel(int level) {
	_audio_level = level;
	UpdateUIWithAudioLevel();
}
///
void CUserListItem::UpdateUIWithStatus() {
	if (_user_status.hasMicrophone()) {
		if (_user_status.isMicrophoneOn()) {
			_btn_status_audio_open->show();
			_btn_status_audio_close->hide();
			UpdateUIWithAudioLevel();
		}
		else {
			_btn_status_audio_open->hide();
			_btn_status_audio_close->show();
			_audio_level = 0;
			UpdateUIWithAudioLevel();
		}
	}
	else {
		_btn_status_audio_open->hide();
		_btn_status_audio_close->hide();
	}

	if (_user_status.hasCamera()) {
		if (_user_status.isCameraOn()) {
			_btn_status_video_open->show();
			_btn_status_video_close->hide();
		}
		else {
			_btn_status_video_open->hide();
			_btn_status_video_close->show();
		}
	}
	else {
		_btn_status_video_open->hide();
		_btn_status_video_close->hide();
	}

	if (_user_status.isScreenOn()) {
		_btn_status_screen_open->show();
	}
	else {
		_btn_status_screen_open->hide();
	}
}
void CUserListItem::UpdateUIWithAudioLevel()  {
	_btn_status_audio_level0->hide();
	_btn_status_audio_level1->hide();
	_btn_status_audio_level2->hide();
	if (_audio_level > 6) {
		_btn_status_audio_level2->show();
	}
	else if (_audio_level > 3) {
		_btn_status_audio_level1->show();
	}
	else if (_audio_level > 0){
		_btn_status_audio_level0->show();
	}
}
void CUserListItem::ReceiveClickEventFromBtn() {
	if (QObject::sender() == _btn_status_audio_close)
	{
		emit clickBtn(this, OperatorOpenAudio);
	}
	else if (QObject::sender() == _btn_status_audio_open)
	{
		emit clickBtn(this, OperatorCloseAudio);
	}
	else if (QObject::sender() == _btn_status_video_close)
	{
		emit clickBtn(this, OperatorOpenVideo);
	}
	else if (QObject::sender() == _btn_status_video_open)
	{
		emit clickBtn(this, OperatorCloseVideo);
	}
}

///
CUserList::CUserList( QWidget* parent, QColor bg_color )
	: CListBase(parent, bg_color) {
}
CUserList::~CUserList() {
	m_userid2listid.clear();
}

void CUserList::AddUser(const tee3::avd::User& aUser) {
	if (!aUser.isValid()) {
		return;
	}
	CUserListItem* user = static_cast<CUserListItem*>(GetItemByItemId(QString::fromUtf8(aUser.userId.c_str())));
	if (NULL != user) {
		UpdateUser(aUser);
		return;
	}
	user = new CUserListItem(this, QString::fromUtf8(aUser.userName.c_str()), QColor(68, 68, 68), QColor(68, 68, 68));
	user->SetId(aUser.nodeId);
	user->SetUserId(aUser.userId);
	user->SetUserStatus(aUser.status);
	m_userid2listid[QString::fromUtf8(aUser.userId.c_str())] = aUser.nodeId;
	PushBack(user);
}

void CUserList::DeleteUser(int userId) {
	Erase(userId);
}

void CUserList::UpdateUser(const tee3::avd::User& aUser) {
	if (!aUser.isValid()) {
		return;
	}
	CUserListItem* user = static_cast<CUserListItem*>(GetItemByItemId(QString::fromUtf8(aUser.userId.c_str())));
	if (NULL == user) {
		AddUser(aUser);
		return;
	}
	user->SetUserStatus(aUser.status);
}

CListItemBase* CUserList::GetItemByItemId(const QString userId) {
	std::map<QString, int>::iterator it = m_userid2listid.find(userId);
	return (m_userid2listid.end() == it) ? NULL : CListBase::GetItemByItemId(it->second);
}
