#ifndef __YH_USER_LIST_H__
#define __YH_USER_LIST_H__

#include "ListItemBase.h"
#include "ListBase.h"
#include "api/common.h"
#include "api/musermanager.h"

using namespace tee3;
using namespace tee3::avd;
class CButton1;
typedef enum{
	OperatorOpenAudio,
	OperatorCloseAudio,
	OperatorOpenVideo,
	OperatorCloseVideo,
}OperatorType;

class CUserListItem : public CListItemBase {
public:
	Q_OBJECT
public:
	 CUserListItem(QWidget* parent, QString user_name, QColor bg_color, QColor bg_hit_color);
	~CUserListItem();
public:
	void SetUserId(const UserId& userId) { m_userId = userId; }
	const UserId GetUserId() const { return m_userId; }
	void SetUserStatus(UserStatus status);
	void SetAudioLevel(int level);
	void ShowRequestOpenVideoBtn(int time);
	void ShowRequestOpenAudioBtn(int time);
protected:
	void pain();
	void resizeEvent(QResizeEvent *event);
	CButton1* createButton(int _right, const char* img);
protected slots:
	void ReceiveClickEventFromBtn();
	void UpdateUIWithStatus();
	void UpdateUIWithAudioLevel();
private:
	tee3::UserId m_userId;
	QString	_user_name;
	UserStatus _user_status;
	int	_audio_level;
	//
	QTimer*	_audio_timer;
	QTimer* _video_timer;
	CButton1* _btn_status_audio_level0;
	CButton1* _btn_status_audio_level1;
	CButton1* _btn_status_audio_level2;
	CButton1* _btn_status_audio_close;
	CButton1* _btn_status_audio_open;
	CButton1* _btn_status_video_close;
	CButton1* _btn_status_video_open;
	CButton1* _btn_status_screen_open;
};

class CUserList : public CListBase {
public:
	 CUserList(QWidget* parent, QColor bg_color);
	~CUserList();
public:
	void AddUser(const tee3::avd::User& aUser);
	void DeleteUser(int userId);
	void UpdateUser(const tee3::avd::User& auser);
	CListItemBase* GetItemByItemId(const QString userId);
private:
	std::map<QString, int> m_userid2listid;
};

#endif //__YH_USER_LIST_H__
