
#ifndef __YX_USER_PAGE_H__
#define __YX_USER_PAGE_H__

#include "RoundRadiusWnd.h"
#include "WidgetSizer.h"
#include "Button1.h"
#include "RoomWindow.h"
#include "api/musermanager.h"

using namespace tee3;
using namespace tee3::avd;
class CButton2;
class CUserList;
class CListItemBase;

class CUserPage : public CRoundRadiusWnd, public CWidgetSizer<CUserPage>, public IMUserManager::IListener
{
public:
	Q_OBJECT
public:
	 CUserPage(RoomWindow* parent);
	~CUserPage();
public:
	void AddSelf();
	void RequestOpenVideo(const QString userId, const QString deviceId);
	void RequestOpenAudio(const QString userId);
	void RegistUserManagerHandle(IMUserManager* userManager);
	bool GetUserID(vector<int>& ids);
	void UpdateAudioLevels(std::vector<std::pair<UserId, int> >& id2levels);

public: // IMUserManager::IListener imp
	void onUserJoinNotify(const User& user) ;
	void onUserLeaveNotify(const User& user) ;
	void onUserUpdateNotify(const User& user) ;
	void onUserStatusNotify(UserStatus status, const UserId& fromId) ;
	void onUserDataNotify(const String& userData, const UserId& fromId) ;
protected:
	void paintEvent(QPaintEvent *event);
	void resizeEvent(QResizeEvent *event);
	protected slots:
	void HandleUserOperate(CListItemBase*, unsigned int);
	void hideWnd();
private:
	RoomWindow*		_roomWnd;
	IMUserManager*  _userManager;
	CButton2*		_close_btn;
	CUserList*		_user_list;
};

#endif