#include "UserReport.h"
#include "Button1.h"
#include "LineEdit.h"
#include "UIManager.h"
#include "MessageBoxFactory.h"


CUserReportPage::CUserReportPage(QWidget* parent)
:QWidget(parent)
{
	_send_btn = new CButton1(this, 400, 11, ":/nice2meet/Resources/image/report_send_btn.png");
	_report_edit = new CLineEdit(0, this, "", QColor(255, 255, 255, 0));
	_report_edit->SetSizer(95, 11, -1, -1, 300, 26);
	_report_edit->SetBackgroundImg(":/nice2meet/Resources/image/repor_text_bg.png");
	_report_edit->HideFrame();
	connect(_send_btn, SIGNAL(click()), this, SLOT(HandleSendReport()));
}

CUserReportPage::~CUserReportPage()
{

}

void CUserReportPage::paintEvent(QPaintEvent *event)
{
	QPainter dc(this);
	dc.fillRect(rect(), QBrush(QColor(135, 187, 196, 255)));
	QRect tagRc(10, 0, rect().width()-10, rect().height());
	dc.setPen(QColor(255, 255, 255));
	dc.drawText(tagRc, Qt::AlignVCenter|Qt::AlignLeft, QSTRING("ף㷴"));

	/*QImage reporTextBgImg(":/nice2meet/Resources/image/repor_text_bg.png");
	QRect reporTextBgRc(75,10,312,27);
	dc.drawImage(reporTextBgRc, reporTextBgImg, QRect(0, 0, reporTextBgImg.width(), reporTextBgImg.height()));*/

}

void CUserReportPage::resizeEvent(QResizeEvent *event)
{
	_send_btn->OnSizer();
	_report_edit->OnSizer();
}

void CUserReportPage::HandleSendReport()
{
	if (!_report_edit->GetText().isEmpty()) {
		MessageBoxFactory::Get()->CreateMessageBox(MessageBoxFactory::ChildAutoBox, this,QColor(), "", QSTRING("ͳɹллı"), 
			QRect(380 + 60 + 10, 0, rect().width() - (380 + 60 + 10), rect().height()), 5000);
		_report_edit->SetText("");
	}
}

void CUserReportPage::keyPressEvent(QKeyEvent *event)
{
	if (event->text() == "\r")
	{
		HandleSendReport();
	}
}
