#ifndef __OPEN_AVD_N2M_VideoLayoutFormat_H__
#define __OPEN_AVD_N2M_VideoLayoutFormat_H__

#include "list"
#include "FrameWindow.h"

class CButton1;
class CVideoRenderWnd;
class CVideoLayoutFormatBase : public QObject
{
public:
	Q_OBJECT
public:
	CVideoLayoutFormatBase();
	CVideoLayoutFormatBase(int width, int heith);
	CVideoLayoutFormatBase(const CVideoLayoutFormatBase& aRight);
	virtual ~CVideoLayoutFormatBase();
	const CVideoLayoutFormatBase& operator = (const CVideoLayoutFormatBase& aRight);
public:
	virtual void AddRenderWnd(QString id, CVideoRenderWnd* render_wnd);
	virtual void RemoveRenderWnd(QString id);
	virtual void SetCenter(const QString id);
	virtual void SetCenter(CVideoRenderWnd* render_wnd);
	virtual void ChangeSizeNotice(int width, int heigth);
	virtual void Layout() = 0;
protected slots:
	void ChangeCenterVideo();
protected:
	int				 _width;
	int				 _heigth;
	QString			 _center_wnd_id;
	CVideoRenderWnd* _center_wnd;
	typedef std::list<CVideoRenderWnd*> VideoViewsType;
	VideoViewsType	 _wnd_list;
};

class CVideoOneByOneLayoutFormat : public CVideoLayoutFormatBase
{
public:
	 CVideoOneByOneLayoutFormat();
	 CVideoOneByOneLayoutFormat(int width, int heigth);
	~CVideoOneByOneLayoutFormat();
public:
	void Layout();
};

class CVideoOneCenterLayoutFormat : public CVideoLayoutFormatBase
{
public:
	Q_OBJECT
public:
	 CVideoOneCenterLayoutFormat();
	 CVideoOneCenterLayoutFormat(int width, int heigth);
	~CVideoOneCenterLayoutFormat();
public:
	void Layout();
	void SetCenter(CVideoRenderWnd* render_wnd);
	int  GetMiniVideoPage(int miniVideoIndex, int numPeerPage);
protected slots:
	void RightPage();
	void LeftPage();
private:
	CButton1* _arrow_right_btn;
	CButton1* _arrow_left_btn;
	int		  _current_page_num;
	int		  _max_page_num ;
};

#endif//__OPEN_AVD_N2M_VideoLayoutFormat_H__
