#ifndef __OPEN_AVD_N2M_VideoRenderWnd_H__
#define __OPEN_AVD_N2M_VideoRenderWnd_H__

#include "WidgetSizer.h"
#include "api/videorender.h"
#include "qtsolutions/qtwinmigrate/src/qwinhost.h"
#include "MainToolWnd.h"
#include <qt_windows.h>

using namespace tee3;
using namespace tee3::avd;
class IVideoRenderer;
class CAutoLabel;
class CVideoShowWnd;

class CVideoRenderWnd : public QWidget, public CWidgetSizer<CVideoRenderWnd>
{
public:
	Q_OBJECT
public:
	CVideoRenderWnd( const QString id, const QString user_name, QWidget* parent);
	virtual ~CVideoRenderWnd();
public:
	void RegistVideo(IVideoRenderer* render);
	IVideoRender* GetRender();
	bool SetScalingType(IVideoRenderView::ScalingType type);
	const QString& getId() const { return _id; }
	void setId(const QString& id) { _id = id; }
	const QString& getRecordId() const { return _recordid; }
	const QString& getLiveId() const { return _liveid; }
	void setRecordId(const QString& id);
	void setLiveId(const QString& id);
	void enableRecord(bool enable);
	void enableLive(bool enable);
public:
	void paintEvent(QPaintEvent *event);
	void resizeEvent(QResizeEvent *event);
	void changeEvent(QEvent *);
	void setBorder(bool hasBorder);
	void setCenter(bool isCenter);
	void mouseDoubleClickEvent(QMouseEvent* event) {
		emit doubleClick();
	}
	void mousePressEvent(QMouseEvent *event);
	void mouseReleaseEvent(QMouseEvent *event);
protected:
	void setLiveState(CButton2M2::STATE state);
	void setRecordState(CButton2M2::STATE state);
signals:
	bool recordStart(const QString& videoId);
	bool recordStop(const QString& recordId);
	bool liveStart(const QString& videoId);
	bool liveStop(const QString& liveId);
	void doubleClick();
	void click();
	void requestCenter();
protected slots:
	bool recordStart();
	bool recordStop();
	bool liveStart();
	bool liveStop();
	void doubleClickSlot();
	void clickSlot();
private:
	QString			_id;
	QString			_user_name;
	QWidget*		_parent;
	QLabel*			_name_lbl;
	CButton2M2*		_record_btn;
	CButton2M2*		_live_btn;
	CVideoShowWnd*	_video_show_wnd;
	bool			_isCenter;
	bool			_hasBorder;
	QString			_recordid;
	QString			_liveid;
};

#endif //__OPEN_AVD_N2M_VideoRenderWnd_H__
