#ifndef __OPEN_AVD_N2M_VideoShowWnd_H__
#define __OPEN_AVD_N2M_VideoShowWnd_H__

#include "WidgetSizer.h"
#include "api/videorender.h"
#include "qtsolutions/qtwinmigrate/src/qwinhost.h"
#include <qt_windows.h>

using namespace tee3;
using namespace tee3::avd;
class IVideoRenderer;
class CButton2M2;

class CVideoShowWnd : public QWinHost, public CWidgetSizer<CVideoShowWnd>
{
public:
	Q_OBJECT
public:
	CVideoShowWnd(const QString id, const QString user_name, QWidget* parent);
	virtual ~CVideoShowWnd();
	static void RegistRenderWndClass();
public:
	void RegistVideo(IVideoRenderer* render);
	IVideoRender* GetRender();
	QString getId(){ return _id; }
	bool SetScalingType(IVideoRenderView::ScalingType type);
public:
	void paintEvent(QPaintEvent *event);
	void resizeEvent(QResizeEvent* event);
	void setBorder(bool hasBorder);
	QPaintEngine * paintEngine() const { return 0; }
	HWND createWindow(HWND parent, HINSTANCE instance);
	void mouseDoubleClickEvent(QMouseEvent* event);
	void mousePressEvent(QMouseEvent *event);
	void mouseReleaseEvent(QMouseEvent *event);
	void focusOutEvent(QFocusEvent *event){}
signals:
	void doubleClick();
	void click();
protected:
	static LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
private:
	QString			_id;
	QString			_user_name;
	QWidget*		_parent;
	float			_width;
	float			_heigth;
	IVideoRenderer*	_render;
	bool			_hasBorder;
	HWND			m_hwnd;
	tee3::avd::IVideoRenderView* m_videoRendererView;
	tee3::avd::IVideoRender*	 m_videoRenderer;
};

#endif //__OPEN_AVD_N2M_VideoShowWnd_H__
