
#include "LoginWnd.h"
#include "RoomWindow.h"
#include "minidump.h"
#include "SettingWindow.h"
#include "../roomprofile.h"
#ifdef QT_STATIC
#include <QtCore/QtPlugin>
Q_IMPORT_PLUGIN(QWindowsIntegrationPlugin);
#endif // QT_STATIC

QApplication* g_app = NULL;
LRESULT CALLBACK WebRtcWinProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch (uMsg) {
	case WM_DESTROY:
		break;
	case WM_COMMAND:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
HWND CreateRenderWindow() {
	HINSTANCE hinst = GetModuleHandle(0);
	WNDCLASSEX wcx;
	wcx.hInstance = hinst;
	wcx.lpszClassName = TEXT("VideoRenderTest");
	wcx.lpfnWndProc = (WNDPROC)WebRtcWinProc;
	wcx.style = CS_DBLCLKS;
	wcx.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wcx.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.lpszMenuName = NULL;
	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.cbClsExtra = 0;
	wcx.cbWndExtra = 0;
	wcx.hbrBackground = GetSysColorBrush(COLOR_3DFACE);

	// Register our window class with the operating system.
	// If there is an error, exit program.
	if (!RegisterClassEx(&wcx)) {
		MessageBox(0, TEXT("Failed to register window class!"), TEXT("Error!"), MB_OK | MB_ICONERROR);
		return 0;
	}

	// Create the main window.
	HWND hwnd = CreateWindowEx(
		0, // no extended styles
		TEXT("VideoRenderTest"), // class name
		TEXT("VideoRenderTest Window"), // window name
		WS_OVERLAPPED | WS_THICKFRAME, // overlapped window
		800, // horizontal position
		0, // vertical position
		400, // width
		300, // height
		(HWND)NULL, // no parent or owner window
		(HMENU)NULL, // class menu used
		hinst, // instance handle
		NULL); // no window creation data

	// Show the window using the flag specified by the program
	// that started the application, and send the application
	// a WM_PAINT message.

	ShowWindow(hwnd, SW_SHOWDEFAULT);
	UpdateWindow(hwnd);
	return hwnd;
}
QApplication* GetApplication() {
	return g_app;
}
int main(int argc, char *argv[]) {
#ifdef WIN32
	InitMinDump();
#endif

	QApplication::addLibraryPath("./plugins");
	QApplication a(argc, argv);
	a.setWindowIcon(CRoomProfile::Instance()->GetAppIcon());

	g_app = &a;
	LoginWindow w;
	w.show();
	return a.exec();
}
