#ifndef __OPEN_AVD_N2M_RoomProfile_H__
#define __OPEN_AVD_N2M_RoomProfile_H__

#include <QtCore/QString>
#include <QtGui/QImage>
#include <QtGui/QIcon>
#include "api/common.h"
#include "api/videorender.h"
using namespace tee3;
using namespace tee3::avd;

class CRoomProfile {
protected:
	 CRoomProfile();
	~CRoomProfile();
public:
	static CRoomProfile* Instance();
	static const QString& getAppKey();
	static const QString& getSecretKey();

	enum VideoPubType{
		vp_single,
		vp_2_codec,
		vp_3_svc,
	};
public:
	QString GetLogo() const;
	QImage  GetTitleBarLogo() const;
	QIcon	GetAppIcon() const;
	///
	const QString& GetSiteUrl() const { return m_siteurl; }
	const QString& GetRootUrl() const { return m_rooturl; }
	const QString& GetInviteUrl();
	const QString& GetRtmpUrl() const { return m_rtmpurl; }
	const QString& GetRoomMode() const { return m_roommode; }
	const QString& GetRoomID() const { return m_roomid; }
	void SetRoomID(const QString& roomId);
	const QString& GetUserID() const { return m_userid; }
	void SetUserID(const QString& userId);
	VideoRatio GetVideoRatio() const { return m_video_ratio; }
	bool SetVideoRatio(VideoRatio value);
	VideoCodec GetVideoCodec() const { return m_video_codec; }
	bool SetVideoCodec(VideoCodec value);
	VideoPubType GetVideoPubType() const { return m_video_pubtype; }
	IVideoRenderView::ScalingType GetRenderType() const { return m_render_scaling_type; }
	const String& GetAudioCodec() const { return m_audio_codec; }
	void SetAudioCodec(const String& value) { m_audio_codec = value; }
	bool SetVideoPubType(VideoPubType value);
	bool IsDtls() const { return m_dtlsflag; }
	bool SetDtls(bool value);
	bool IsDataTcp() const { return m_datatcp; }
	bool SetDataTcp(bool value);
	bool IsAutoVideo() const { return m_auto_video; }
	bool SetAutoVideo(bool value);
	bool IsAutoAudio() const { return m_auto_audio; }
	bool SetAutoAudio(bool value);
	bool SetRenderType(tee3::avd::IVideoRenderView::ScalingType renderType);
	bool HasLivecast() const { return m_has_livecast; }
	bool SetLivecast(bool value);
	bool IsMainBroadcaster () const { return m_ismainbroadcaster; }
	void SetMainBroadcaster(bool value);
	MixerVideoLayoutType GetLivecastVideoLayout() const { return m_lvvideolayout; }
	void SetLivecastVideoLayout(MixerVideoLayoutType value);
	bool IsUseGDIRender() const { return m_usedGDIRender; }
protected:
	bool loadProfileFile();
	void writeSetting(const QString &key, const QVariant &value);
protected:
	QString		m_siteurl;
	QString		m_rooturl;
	QString		m_inviteurl;
	QString		m_rtmpurl;
	QString		m_roomid;
	QString		m_userid;
	QString		m_roommode;
	bool		m_dtlsflag;
	bool		m_datatcp;
	bool		m_auto_audio;
	bool		m_auto_video;
	bool		m_has_livecast;
	VideoRatio	m_video_ratio;
	VideoCodec	m_video_codec;
	VideoPubType	m_video_pubtype;
	CameraCapability m_maxcap;
	IVideoRenderView::ScalingType m_render_scaling_type;
	String		m_audio_codec;
	bool		m_ismainbroadcaster;
	MixerVideoLayoutType m_lvvideolayout;
	bool		m_usedGDIRender;
};

#endif //__OPEN_AVD_N2M_RoomProfile_H__
